use nalgebra::Vector2;

#[derive(Debug, Clone)]
pub(crate) struct Camera {
	/// The position of the camera, in game units
	pos: Vector2<f32>,

	/// The height of the viewport, in game units.
	zoom: f32,
}

impl Camera {
	pub fn new() -> Self {
		Self {
			pos: Vector2::new(0.0, 0.0),
			zoom: 500.0,
		}
	}

	pub fn set_pos(&mut self, pos: Vector2<f32>) {
		self.pos = pos
	}

	pub fn get_pos(&self) -> Vector2<f32> {
		self.pos
	}

	pub fn set_zoom(&mut self, zoom: f32) {
		self.zoom = zoom
	}

	pub fn get_zoom(&self) -> f32 {
		self.zoom
	}
}
