/// An action the player wants to take in the game.
#[derive(Debug, Clone)]
pub enum PlayerDirective {
	/// Do nothing
	None,

	/// Set main engine state
	Engine(bool),

	/// Set left turn thruster state
	TurnLeft(bool),

	/// Set right turn thruster state
	TurnRight(bool),

	/// Set main gun state
	Guns(bool),

	/// Land on the currently selected planet
	Land,

	/// Take off from the planet we're landed on
	UnLand,
}
